VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cToolTip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function CreateWindowEx _
                          Lib "user32" _
                              Alias "CreateWindowExA" (ByVal dwExStyle As Long, _
                                                       ByVal lpClassName As String, _
                                                       ByVal lpWindowName As String, _
                                                       ByVal dwStyle As Long, _
                                                       ByVal x As Long, _
                                                       ByVal y As Long, _
                                                       ByVal nWidth As Long, _
                                                       ByVal nHeight As Long, _
                                                       ByVal hWndParent As Long, _
                                                       ByVal hMenu As Long, _
                                                       ByVal hInstance As Long, _
                                                       lpParam As Any) As Long

Private Declare Function SendMessage _
                          Lib "user32" _
                              Alias "SendMessageA" (ByVal hwnd As Long, _
                                                    ByVal wMsg As Long, _
                                                    ByVal wParam As Long, _
                                                    lParam As Any) As Long

Private Declare Function SendMessageLong _
                          Lib "user32" _
                              Alias "SendMessageA" (ByVal hwnd As Long, _
                                                    ByVal wMsg As Long, _
                                                    ByVal wParam As Long, _
                                                    ByVal lParam As Long) As Long

Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function FindWindow _
                          Lib "user32" _
                              Alias "FindWindowA" (ByVal lpClassName As String, _
                                                   ByVal lpWindowName As String) As Long

''Windows API Constants
Private Const WM_USER = &H400
Attribute WM_USER.VB_VarUserMemId = 1073741826

Private Const CW_USEDEFAULT = &H80000000

''Windows API Types
Private Type RECT

    Left As Long
    Top As Long
    Right As Long
    Bottom As Long

End Type

''Tooltip Window Constants
Private Const TTS_NOPREFIX = &H2
Attribute TTS_NOPREFIX.VB_VarUserMemId = 1073741829

Private Const TTF_TRANSPARENT = &H100
Attribute TTF_TRANSPARENT.VB_VarUserMemId = 1073741833

Private Const TTF_CENTERTIP = &H2
Attribute TTF_CENTERTIP.VB_VarUserMemId = 1073741834

Private Const TTM_ADDTOOLA = (WM_USER + 4)
Attribute TTM_ADDTOOLA.VB_VarUserMemId = 1610809345

Private Const TTM_ACTIVATE = WM_USER + 1

Private Const TTM_UPDATETIPTEXTA = (WM_USER + 12)

Private Const TTM_SETMAXTIPWIDTH = (WM_USER + 24)

Private Const TTM_SETTIPBKCOLOR = (WM_USER + 19)

Private Const TTM_SETTIPTEXTCOLOR = (WM_USER + 20)

Private Const TTM_SETTITLE = (WM_USER + 32)

Private Const TTS_BALLOON = &H40

Private Const TTS_ALWAYSTIP = &H1
Attribute TTS_ALWAYSTIP.VB_VarUserMemId = 1610612737

Private Const TTF_SUBCLASS = &H10

Private Const TTF_IDISHWND = &H1

Private Const TTM_SETDELAYTIME = (WM_USER + 3)

Private Const TTDT_AUTOPOP = 2

Private Const TTDT_INITIAL = 3
Attribute TTDT_INITIAL.VB_VarUserMemId = 1610809345

Private Const TOOLTIPS_CLASSA = "tooltips_class32"

''Tooltip Window Types
Private Type TOOLINFO

    lSize As Long
    lFlags As Long
    hwnd As Long
    lId As Long
    lpRect As RECT
    hInstance As Long
    lpStr As String
    lParam As Long

End Type

'Public Enum ttIconType

'TTNoIcon = 0
'TTIconInfo = 1
'TTIconWarning = 2
'TTIconError = 3

'End Enum

'Public Enum ttStyleEnum'

'TTStandard
'TTBalloon

'End Enum

'local variable(s) to hold property value(s)
Private mvarBackColor As Long

Private mvarTitle As String

Private mvarForeColor As Long

Private mvarIcon As ttIconType

Private mvarCentered As Boolean

Private mvarStyle As ttStyleEnum

Private mvarTipText As String

Private mvarVisibleTime As Long

Private mvarDelayTime As Long

'private data
Private m_lTTHwnd As Long  ' hwnd of the tooltip

Private m_lParenthWnd As Long  ' hwnd of the window the tooltip attached to

Private ti As TOOLINFO

''' // Initialize Class
''' // Adjust timings according to your needs
Private Sub Class_Initialize()

    mvarDelayTime = 50
    mvarVisibleTime = 1700

End Sub
Private Sub Class_Terminate()

    Destroy

End Sub
''' // Create the Tooltip Window
Public Function Create(ByVal ParentHwnd As Long) As Boolean
Attribute Create.VB_UserMemId = 1610809355

    Dim lWinStyle As Long

    Dim appHWnd As Long

    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
    End If

    m_lParenthWnd = ParentHwnd

    lWinStyle = TTS_ALWAYSTIP Or TTS_NOPREFIX

    ''create baloon style if desired
    If mvarStyle = TTBalloon Then lWinStyle = lWinStyle Or TTS_BALLOON

    ''' // If Excel Ver. < Excel 2002 use a different approach for getting handle to Application; we simply use the general Application handle instead of an instance handle.
    ''' // This was tested to work out correctly in case 2 instances of Excel are running ...
    'appHWnd = FindWindow("XLMAIN", vbNullString)
    'Else
    'appHWnd = App.hInstance
    'End If

    m_lTTHwnd = CreateWindowEx(0&, TOOLTIPS_CLASSA, vbNullString, lWinStyle, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 0&, 0&, appHWnd, 0&)

    ''now set our tooltip info structure
    With ti

        ''if we want it centered, then set that flag
        If mvarCentered Then
            .lFlags = TTF_SUBCLASS Or TTF_CENTERTIP Or TTF_IDISHWND
        Else
            .lFlags = TTF_SUBCLASS Or TTF_IDISHWND
        End If

        ''set the hwnd prop to our parent control's hwnd
        .hwnd = m_lParenthWnd
        .lId = m_lParenthWnd       '0
        .hInstance = appHWnd    'Application.hInstance
        '.lpstr    = ALREADY SET
        '.lpRect   = lpRect
        .lSize = Len(ti)
    End With

    ''add the tooltip structure
    SendMessage m_lTTHwnd, TTM_ADDTOOLA, 0&, ti

    ''if we want a title or we want an icon
    If mvarTitle <> vbNullString Or mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If

    If mvarForeColor <> Empty Then
        SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
    End If

    If mvarBackColor <> Empty Then
        SendMessage m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
    End If

    SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, mvarVisibleTime
    SendMessageLong m_lTTHwnd, TTM_SETDELAYTIME, TTDT_INITIAL, mvarDelayTime

End Function
Public Sub Destroy()
Attribute Destroy.VB_UserMemId = 1610809356

    If m_lTTHwnd <> 0 Then
        DestroyWindow m_lTTHwnd
    End If

End Sub
''' // All Tooltip Properties:
Public Property Let Style(ByVal vData As ttStyleEnum)
'used when assigning a value to the property, on the left side
'of an assignment.
'Syntax: X.Style = 5
    mvarStyle = vData

End Property

Public Property Get Style() As ttStyleEnum
Attribute Style.VB_UserMemId = 1745027080
'used when retrieving value of a property, on the right side
'of an assignment.
'Syntax: Debug.Print X.Style
    Style = mvarStyle
End Property

Public Property Let Centered(ByVal vData As Boolean)
'used when assigning a value to the property, on the left side
'of an assignment.
'Syntax: X.Centered = 5
    mvarCentered = vData
End Property

Public Property Get Centered() As Boolean
Attribute Centered.VB_UserMemId = 1745027079
'used when retrieving value of a property, on the right side
'of an assignment.
'Syntax: Debug.Print X.Centered
    Centered = mvarCentered
End Property
Public Property Let Icon(ByVal vData As ttIconType)
    mvarIcon = vData

    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If

End Property

Public Property Get Icon() As ttIconType
Attribute Icon.VB_UserMemId = 1745027078
    Icon = mvarIcon
End Property

Public Property Let ForeColor(ByVal vData As Long)
    mvarForeColor = vData

    If m_lTTHwnd <> 0 Then
        SendMessage m_lTTHwnd, TTM_SETTIPTEXTCOLOR, mvarForeColor, 0&
    End If

End Property

Public Property Get ForeColor() As Long
Attribute ForeColor.VB_UserMemId = 1745027077
    ForeColor = mvarForeColor
End Property
Public Property Let Title(ByVal vData As String)
    mvarTitle = vData

    If m_lTTHwnd <> 0 And mvarTitle <> Empty And mvarIcon <> TTNoIcon Then
        SendMessage m_lTTHwnd, TTM_SETTITLE, CLng(mvarIcon), ByVal mvarTitle
    End If

End Property

Public Property Get Title() As String
Attribute Title.VB_UserMemId = 1745027076
    Title = ti.lpStr
End Property

Public Property Let BackColor(ByVal vData As Long)
    mvarBackColor = vData

    If m_lTTHwnd <> 0 Then
        SendMessage m_lTTHwnd, TTM_SETTIPBKCOLOR, mvarBackColor, 0&
    End If

End Property

Public Property Get BackColor() As Long
Attribute BackColor.VB_UserMemId = 1610809349
    BackColor = mvarBackColor
End Property

Public Property Let TipText(ByVal vData As String)
    mvarTipText = vData
    ti.lpStr = vData

    If m_lTTHwnd <> 0 Then
        SendMessage m_lTTHwnd, TTM_UPDATETIPTEXTA, 0&, ti
    End If

End Property

Public Property Get TipText() As String
Attribute TipText.VB_UserMemId = 1610809351
    TipText = mvarTipText
End Property

Public Property Get VisibleTime() As Long
Attribute VisibleTime.VB_UserMemId = 1610809350
    VisibleTime = mvarVisibleTime
End Property

Public Property Let VisibleTime(ByVal LDATA As Long)
    mvarVisibleTime = LDATA
End Property

Public Property Get DelayTime() As Long
    DelayTime = mvarDelayTime
End Property

Public Property Let DelayTime(ByVal LDATA As Long)
    mvarDelayTime = LDATA
End Property
